<?php

if( isset( $_POST[ "status" ] ) && isset( $_POST[ "typ" ] ) && isset( $_POST[ "geraet" ] ) && isset( $_POST[ "schluessel" ] ) ) {

	/*
	* Author: Jens Herdy
	* Author URL: https://www.randnotizen.org/
	* Manual URL: https://www.randnotizen.org/fritzbox-aha-avm-home-automation-mit-google-home-steuern/
	* Version: 1.1
	* Description: Script to receive a call by url and make console commands to control AVM AHA Smart Home devices
	* License: GPLv3
	*/

	// Variablen absichern und mit POST Daten füllen
	$status = preg_replace("/[^a-zA-Z0-9]/", "", $_POST["status"]);
	$typ = preg_replace("/[^a-zA-Z0-9]/", "", $_POST["typ"]);
	$geraet = preg_replace("/[^a-zA-Z0-9]/", "", $_POST["geraet"]);
	$schluessel = preg_replace("/[^a-zA-Z0-9]/", "", $_POST["schluessel"]);

	/*
	* Allgemeine Variablen & Einstellungen
	*/
	
	// Erlaubte Geräte
	$erlaubtegeraete = array(
		"Geraetename1",
		"Geraetename2",
		"Thermostate",
		"GutenMorgen",
		"GuteNacht",
	);
	
	// Erlaubte Status
	$erlaubtestatus = array(
		"on",
		"off",
		"toggle",
		"18",
		"19",
		"20",
		"21",
		"22",
		"23",
		"24",
		"25",
		"26",
	);
	
	// Verbotene Status 300
	$verboten300 = array(
		"on",
		"off",
		"toggle",
	);
	
	// Verbotene Status 200
	$verboten200 = array(
		"18",
		"19",
		"20",
		"21",
		"22",
		"23",
		"24",
		"25",
		"26",
	);
	
	// Erlaubte Typen
	$erlaubtetypen = array(
		"200",
		"300",
	);
	
	// Erlaubte Schlüssel
	$erlaubteschluessel = array(
		"KEYEINFÜGEN",
	);
	
	// Geräte abschalten verhindern
	$abschaltenverhindern = array(
		"Geraetename2",
	);
		
	// Geräte umschalten verhindern
	$umschaltenverhindern = array(
		"Geraetename2",
	);
	
	/*
	* Allgemeines überprüfen der Variablen
	*/

	// Prüfen ob Gerät erlaubt
	if( !in_array($geraet, $erlaubtegeraete) ) {
		exit;
	}
	
	// Prüfen ob Status erlaubt
	elseif( !in_array($status, $erlaubtestatus) ) {
		exit;
	}
	
	// Prüfen ob Typ erlaubt
	elseif( !in_array($typ, $erlaubtetypen) ) {
		exit;
	}
	
	// Prüfen ob Schlüssel erlaubt
	elseif( !in_array($schluessel, $erlaubteschluessel) ) {
		exit;
	}
	
	/*
	* Zusammenhänge prüfen
	*/
	
	// Prüfen ob Typ 200 und abschalten verhindern
	elseif( $erlaubtetypen == "200" && in_array($geraet, $abschaltenverhindern) && $status == "off" ) {
		exit;
	}
	
	// Prüfen ob Typ 200 und Status verhindern
	elseif( $erlaubtetypen == "200" && in_array($geraet, $verboten200) ) {
		exit;
	}
	
	// Prüfen ob Typ 300 und Status verhindern
	elseif( $erlaubtetypen == "300" && in_array($geraet, $verboten300) ) {
		exit;
	}
	
	// Prüfen ob Typ 200 und umschalten verhindern
	elseif( $erlaubtetypen == "200" && in_array($geraet, $umschaltenverhindern) && $status == "toggle" ) {
		exit;
	}
	
	/*
	* Befehle ausführen
	*/
	
	// Befehl ausführen - Umschalten
	elseif( $typ == "200" && $status == "toggle" ) {
		shell_exec("fritzctl toggle '$geraet'");
	}
	
	// Befehl ausführen - GutenMorgen
	elseif( $typ == "200" && $geraet == "GutenMorgen" && $status == "on" ) {
		shell_exec("fritzctl switch '$status' Geraetename1");
		shell_exec("fritzctl switch '$status' Geraetename2");
	}
	
	// Befehl ausführen - GuteNacht
	elseif( $typ == "200" && $geraet == "GuteNacht" && $status == "off" ) {
		shell_exec("fritzctl switch '$status' Geraetename1");
		shell_exec("fritzctl switch '$status' Geraetename2");
	}
	
	// Befehl ausführen - Temp
	elseif( $typ == "300" && $geraet == "Thermostate" ) {
		shell_exec("fritzctl temperature '$status' Geraetename3 Geraetename4 Geraetename5 Geraetename6");
	}
	
	// Befehl ausführen - Rest
	else {
		shell_exec("fritzctl switch '$status' '$geraet'");
	}
	
}

?>